unit U_TatClothRKHZList2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, MovePanel, Math, Clipbrd,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, cxTextEdit, dxSkinsCore,
  dxSkinsDefaultPainters, dxDateRanges, dxBarBuiltInMenu, U_BaseInput, cxPC,
  System.StrUtils, dxScrollbarAnnotations, U_BaseList, System.ImageList,
  Vcl.ImgList;
type
  TfrmTatClothRKHZList2 = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DS_1: TDataSource;
    GPM_1: TcxGridPopupMenu;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_1: TClientDataSet;
    begtime: TDateTimePicker;
    endTime: TDateTimePicker;
    IsJYTime: TCheckBox;
    ToolButton4: TToolButton;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column22: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    Label5: TLabel;
    C_Name: TEdit;
    PM_1: TPopupMenu;
    PM11: TMenuItem;
    N1: TMenuItem;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column7: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Tv1Column13: TcxGridDBColumn;
    Tv1Column14: TcxGridDBColumn;
    Tv1Column17: TcxGridDBColumn;
    Tv1Column18: TcxGridDBColumn;
    Tv1Column19: TcxGridDBColumn;
    Label1: TLabel;
    C_Width: TEdit;
    Label3: TLabel;
    C_GramWeight: TEdit;
    Tv1IOType: TcxGridDBColumn;
    IOType: TComboBox;
    Label4: TLabel;
    Label6: TLabel;
    PCID: TEdit;
    Tv1issp: TcxGridDBColumn;
    Tv1YdPF: TcxGridDBColumn;
    Tv1edPF: TcxGridDBColumn;
    Tv1xjPF: TcxGridDBColumn;
    Tv1fqPF: TcxGridDBColumn;
    Tv1csPF: TcxGridDBColumn;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure orderNoKeyPress(Sender: TObject; var Key: Char);
    procedure BTNPClick(Sender: TObject);
    procedure BTLPClick(Sender: TObject);
    procedure TCBNORChange(Sender: TObject);
    procedure JYTypeChange(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure cxPageControl1Change(Sender: TObject);
    procedure CDS_1BeforeOpen(DataSet: TDataSet);
    procedure Tv1DataControllerFilterBeforeChange(Sender: TcxDBDataFilterCriteria; ADataSet: TDataSet; const AFilterText: string);

    procedure Tv1TcxGridDBDataControllerTcxDataSummaryFooterSummaryItems6GetText(Sender: TcxDataSummaryItem; const AValue: Variant; AIsFooter: Boolean; var AText: string);
    procedure ToolButton4Click(Sender: TObject);
    procedure PM11Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure IsJYTimeClick(Sender: TObject);
    procedure C_NameKeyPress(Sender: TObject; var Key: Char);
    procedure IOTypeChange(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    CurrentPage, RecordsNumber: Integer;
    lstCust: TStringList;
    procedure InitGrid();
    procedure SetStatus();
    procedure CopyColumnSummaryToClipboard(AColumn: TcxGridColumn);
    { Private declarations }
  public
    fissp : string;
    fC_Name: string;
    fioType : string;
    fC_GramWeight : string;
    fEndDateTime,fBegDateTime : TDateTime;
    { Public declarations }
  end;

var
  frmTatClothRKHZList2: TfrmTatClothRKHZList2;

implementation

uses
  U_DataLink, U_RTFun, U_LabelPrint;

{$R *.dfm}

procedure TfrmTatClothRKHZList2.SetStatus();
begin

end;

procedure TfrmTatClothRKHZList2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  FreeAndNil(lstCust);
  Action := caFree;
end;

procedure TfrmTatClothRKHZList2.FormCreate(Sender: TObject);
begin
  inherited;
  lstCust := TStringList.Create;
  EndDate.DateTime := SGetServerDateTime(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 20;
end;

procedure TfrmTatClothRKHZList2.InitGrid();
var
  WSql: string;
begin

  WSql := SGetFilters(Panel1, 1, 2);
  if Trim(WSql) <> '' then
    WSql := ' and ' + WSql;
  if IsJYTime.Checked then
  begin
    WSql := WSql + ' and IOTime>=' + quotedstr(FormatDateTime('yyyy-MM-dd', BegDate.DateTime));
    WSql := WSql + ' and IOTime<' + quotedstr(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1));
  end;

  try
    ADOQueryMain.DisableControls;

    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;

//      sql.Add('select C_NAME, C_width,C_GramWeight,pcid,max(IOType) as IOType  ');
      sql.Add('select C_NAME,C_GramWeight,pcid,iotype,C_WIDTH ');
      SQL.Add(',pf=SUM(CASE WHEN (GRADE=''优等品'' or GRADE=''二等品'' or GRADE=''小卷'' or GRADE=''分切'' or GRADE=''测试'') THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) else 0 end )');
      SQL.Add(',SUM(CASE WHEN GRADE=''优等品'' THEN 1 ELSE 0 END )AS YDJS');
      SQL.Add(',SUM(CASE WHEN GRADE=''优等品'' THEN meter ELSE 0 END )AS Ydqty');
      SQL.Add(',SUM(CASE WHEN GRADE=''优等品'' THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) ELSE 0 END )AS YdPF');

      SQL.Add(',SUM(CASE WHEN GRADE=''二等品'' THEN 1 ELSE 0 END )AS edJS');
      SQL.Add(',SUM(CASE WHEN GRADE=''二等品'' THEN meter ELSE 0 END )AS edqty');
      SQL.Add(',SUM(CASE WHEN GRADE=''二等品'' THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) ELSE 0 END )AS edPF');

      SQL.Add(',SUM(CASE WHEN GRADE=''小卷'' THEN 1 ELSE 0 END )AS xjJS');
      SQL.Add(',SUM(CASE WHEN GRADE=''小卷'' THEN meter ELSE 0 END )AS xjqty');
      SQL.Add(',SUM(CASE WHEN GRADE=''小卷'' THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) ELSE 0 END )AS xjPF');

//      SQL.Add(',SUM(CASE WHEN GRADE=''废布'' THEN 1 ELSE 0 END )AS fbJS');
//      SQL.Add(',SUM(CASE WHEN GRADE=''废布'' THEN meter ELSE 0 END )AS fbqty');
//      SQL.Add(',SUM(CASE WHEN GRADE=''废布'' THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) ELSE 0 END )AS fbPF');

      SQL.Add(',SUM(CASE WHEN GRADE=''分切'' THEN 1 ELSE 0 END )AS fqJS');
      SQL.Add(',SUM(CASE WHEN GRADE=''分切'' THEN meter ELSE 0 END )AS fqqty');
      SQL.Add(',SUM(CASE WHEN GRADE=''分切'' THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) ELSE 0 END )AS fqPF');

//      SQL.Add(',SUM(CASE WHEN GRADE=''循环布'' THEN 1 ELSE 0 END )AS xhJS');
//      SQL.Add(',SUM(CASE WHEN GRADE=''循环布'' THEN meter ELSE 0 END )AS xhqty');
      SQL.Add(',SUM(CASE WHEN GRADE=''测试'' THEN 1 ELSE 0 END )AS csJS');
      SQL.Add(',SUM(CASE WHEN GRADE=''测试'' THEN meter ELSE 0 END )AS csqty');
      SQL.Add(',SUM(CASE WHEN GRADE=''测试'' THEN meter/100*CAST(C_WIDTH AS DECIMAL(18,2)) ELSE 0 END )AS csPF');

      sql.Add(',issp=isnull(A.issp,'''') ');
      SQL.Add('from   V_Tat_Cloth_IO A where (A.IOFlag = ''入库'' ) ' + WSql);
      sql.Add(' and C_NAME=' + QuotedStr(Trim(fC_Name)));
      sql.Add(' and ioType=' + QuotedStr(Trim(fioType)));
      sql.Add(' and C_GramWeight=' + QuotedStr(Trim(fC_GramWeight)));
      SQL.Add(' and Grade <> ''废布'' ');
      SQL.Add(' and Grade <> ''循环布'' ');

      if fissp <> '' then
      begin
        SQL.Add(' and isnull(issp,'''') = ''双喷''' );
      end
      else
      begin
        SQL.Add(' and isnull(issp,'''') <> ''双喷'' ' );
      end;

      sql.Add('group by C_NAME, C_width,C_GramWeight,IOType,pcid,isnull(A.issp,'''')');
//      sql.Add('group by C_NAME, IOType,C_GramWeight,pcid,isnull(A.issp,'''')');
      sql.Add('Order by C_NAME, C_width,pcid,C_GramWeight ');
//      sql.Add('Order by C_NAME, IOType,C_GramWeight ');
//            showmessage(sql.text);
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_1);
    SInitCDSData(ADOQueryMain, CDS_1);

  finally
    ADOQueryMain.EnableControls;
    TV1.DataController.Filter.Clear;
  end;

end;

procedure TfrmTatClothRKHZList2.IOTypeChange(Sender: TObject);
begin

  InitGrid();
end;

procedure TfrmTatClothRKHZList2.IsJYTimeClick(Sender: TObject);
begin
  inherited;
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.TBRafreshClick(Sender: TObject);
begin
  CurrentPage := 1;
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.CDS_1BeforeOpen(DataSet: TDataSet);
begin

  lstCust.Clear;
end;

procedure TfrmTatClothRKHZList2.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmTatClothRKHZList2.cxPageControl1Change(Sender: TObject);
begin
  CurrentPage := 1;
  SetStatus();
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.C_NameKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then
  begin
    InitGrid();
  end;
end;

procedure TfrmTatClothRKHZList2.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmTatClothRKHZList2.FormShow(Sender: TObject);
begin
  inherited;

  ReadCxGrid(trim(self.Caption) + 'Tv1', Tv1, '成品入库汇总2');
  CurrentPage := 1;
  RecordsNumber := 500;
//  canshu1 := Trim(Self.fParameters1);

  EndDate.DateTime := fEndDateTime;
  BegDate.DateTime := fBegDateTime;
  SetStatus();

  InitGrid();

end;

procedure TfrmTatClothRKHZList2.TBExportClick(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    exit;
  with CDS_1 do
  begin
    Filtered := false;
    Filter := ' ssel = 1';
    Filtered := true;
  end;
  TcxGridToExcel(Self.Caption, cxGrid1);
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.orderNoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    CurrentPage := 1;
    InitGrid();
  end;
end;

procedure TfrmTatClothRKHZList2.PM11Click(Sender: TObject);
begin
  SelOKNo(CDS_1, false);
end;

procedure TfrmTatClothRKHZList2.Tv1DataControllerFilterBeforeChange(Sender: TcxDBDataFilterCriteria; ADataSet: TDataSet; const AFilterText: string);
begin
  lstCust.Clear;
end;

procedure TfrmTatClothRKHZList2.Tv1TcxGridDBDataControllerTcxDataSummaryFooterSummaryItems6GetText(Sender: TcxDataSummaryItem; const AValue: Variant; AIsFooter: Boolean; var AText: string);
begin
  if lstCust <> nil then
    AText := IntToStr(lstCust.Count);
end;

procedure TfrmTatClothRKHZList2.BTNPClick(Sender: TObject);
begin
  if CurrentPage < CDS_1.FieldByName('TotalCount').AsInteger / RecordsNumber then
    CurrentPage := CurrentPage + 1;
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.BTLPClick(Sender: TObject);
begin
  if CurrentPage > 1 then
    CurrentPage := CurrentPage - 1;
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.TCBNORChange(Sender: TObject);
begin

  CurrentPage := 1;
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.JYTypeChange(Sender: TObject);
begin
  CurrentPage := 1;
  InitGrid();
end;

procedure TfrmTatClothRKHZList2.N1Click(Sender: TObject);
begin

  SelOKNo(CDS_1, true);
end;

procedure TfrmTatClothRKHZList2.N2Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_1.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmTatClothRKHZList2.N3Click(Sender: TObject);
begin
  CopyColumnSummaryToClipboard(TV1.Controller.FocusedColumn);
end;

procedure TfrmTatClothRKHZList2.CopyColumnSummaryToClipboard(AColumn: TcxGridColumn);
var
  AView: TcxGridDBTableView;
  SummaryIndex: Integer;
  SummaryText: string;
begin
  AView := Tv1;

  // 查找指定列的汇总项
  SummaryIndex := AView.DataController.Summary.FooterSummaryItems.IndexOfItemLink(AColumn);
  if SummaryIndex <> -1 then
  begin
    SummaryText := AView.DataController.Summary.FooterSummaryTexts[SummaryIndex];
    Clipboard.AsText := SummaryText;
  end
  else
    ShowMessage('未找到该列的汇总数据');
end;

procedure TfrmTatClothRKHZList2.ToolButton2Click(Sender: TObject);
var
  WSql: string;
begin
  if CDS_1.IsEmpty then
    Exit;
  if not CDS_1.Locate('SSel', True, []) then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  WSql := '';
  CDS_1.DisableControls;
  with CDS_1 do
  begin
    First;
    while not Eof do
    begin
      if CDS_1.fieldbyname('SSel').AsBoolean then
      begin
        if WSql <> '' then
        begin
          WSql := WSql + ',' + QuotedStr(Trim(CDS_1.fieldbyname('CIID').AsString));
        end
        else
        begin
          WSql := QuotedStr(Trim(CDS_1.fieldbyname('CIID').AsString));
        end;
      end;
      Next;
    end;
  end;
  CDS_1.Locate('SSel', True, []);
  CDS_1.EnableControls;
  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'TradeClothStk';
      FFiltration1 := WSql;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmTatClothRKHZList2.ToolButton4Click(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption) + 'Tv1', Tv1, '成品入库汇总2');
end;

end.

